#include "tbb/concurrent_queue.h"
#include <stdio.h>
#include <pthread.h>

using namespace tbb;
using namespace std;

concurrent_queue<int> queue;

extern "C"
{
  void * producer( void* )
  {
    for( int i=0; i<100; i++ ) { queue.push( i ); }
    return 0;
  }

  void * consumer( void* )
  {
    int value = 0;
    while ( value != 99 )
    {
      queue.pop( value );
      printf( "Value=%i\n", value );
    }
    return 0;
  }
}

int main()
{
  pthread_t threads[2];
  pthread_create( &threads[0], 0, producer, 0 );
  pthread_create( &threads[1], 0, consumer, 0 );
  pthread_join( threads[1], 0 );
  pthread_join( threads[0], 0 );
  return 0;
}
