#include <unistd.h>
#include <stdio.h>
#include <semaphore.h>

void main()
{
  int status;
  pid_t f = fork();
  sem_t * semaphore;
  semaphore = sem_open( "/my_semaphore", O_CREAT, 0777, 1 );
  if ( f == 0 )
  { /* Child process */
    printf( "Child process completed\n" );
    sem_post( semaphore );
    sem_close( semaphore );
  }
  else
  {
    sem_t * semaphore;
    sem_wait( semaphore );
    printf( "Parent process completed\n" );
    sem_close( semaphore );
    sem_unlink( "my_semaphore" );
  }
}
