#include <pthread.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <strings.h>
#include <arpa/inet.h>

void * handleecho( void * param )
{
   char buffer[1024];
   pthread_detach( pthread_self() );
   int s = (int)param;
   int count;
   while ( count = read( s, buffer, 1023 ) > 0 )
   {
     buffer[count] = 0;
     printf( "Received %s \n", buffer );
     write( s, buffer, count );
   }
   close( s );
}


void main()
{
  int newsocket;
  int s = socket( AF_INET, SOCK_STREAM, 0 ); // TCP/IP socket
  struct sockaddr_in server;
  bzero( &server, sizeof(server) );          // Clear address structure
  server.sin_family = AF_INET;               // TCP/IP family
  server.sin_addr.s_addr = inet_addr( "127.0.0.1" );
                                             // Any address
  server.sin_port = 7779;                    // Port to bind to
  bind( s, (struct sockaddr*)&server, sizeof(server) );
  listen( s, 5 ); // Queue of five outstanding connections

  while ( newsocket = accept( s, 0, 0 ) )
  {
    pthread_t thread;
    pthread_create( &thread, 0, handleecho, (void*) newsocket );
  }
}
