#include <Windows.h>

int _tmain(int argc, _TCHAR* argv[])
{
  STARTUPINFO startup_info;
  PROCESS_INFORMATION process_info;

  HANDLE filehandle;
  TCHAR ID[] = TEXT("Local\\sharedmemory");
  char* memory;

  if (argc==1)
  {
    filehandle = CreateFileMapping( INVALID_HANDLE_VALUE,
                                    NULL, PAGE_READWRITE, 0, 1024, ID);
    memory = (char*)MapViewOfFile( filehandle, FILE_MAP_ALL_ACCESS, 0, 0, 0 );
    sprintf_s( memory, 1024, "%s", "Data from first process" );
    printf( "First process: %s\n", memory );

    ZeroMemory( &process_info, sizeof(process_info) );
    ZeroMemory( &startup_info, sizeof(startup_info) );
    startup_info.cb = sizeof(startup_info);
    
    wchar_t commandline[256];
    wsprintf( commandline, L"\"%s\" Child\n", argv[0] );
    
    CreateProcessW( argv[0], commandline, 0, 0, 0, 0, 0, 0, 
                    &startup_info, &process_info );
    WaitForSingleObject(process_info.hProcess,INFINITE);
    
    UnmapViewOfFile( memory );
    CloseHandle( filehandle );
  }
  else
  {
    filehandle = OpenFileMapping( FILE_MAP_ALL_ACCESS, 0, ID );
    memory = (char*)MapViewOfFile( filehandle, FILE_MAP_ALL_ACCESS, 0, 0, 0 );

    printf( "Second process: %s\n", memory ); 
 
    UnmapViewOfFile( memory );
    CloseHandle( filehandle ); 
  }
  getchar();
  return 0;
}
