#include <stdlib.h>

typedef struct s
{
  struct s* next;
} S;

void setuplist( S *current )
{
  for(int i=0; i<1000000; i++)
  {
    current->next = (S*)malloc( sizeof(S) );
    current = current->next;
  }
  current->next = NULL;
}

int main()
{
  S var1, var2;
  #pragma omp parallel sections
  {
    #pragma omp section
    {
      setuplist( &var1 );   // Set up first linked list
    }
    #pragma omp section
    {
      setuplist( &var2 );   // Set up second linked list
    }
  }
}
