#include<stdio.h>
#include<stdlib.h>

int inSet( double ix, double iy )
{
  int    iterations = 0;
  double x = ix, y = iy;
  double x2 = x*x, y2 = y*y;
  while ( (x2 + y2 < 4) && (iterations < 1000) )  /* Line 9 */
  {
    y = 2*x*y + iy;
    x = x2 - y2 + ix;
    x2= x*x;
    y2= y*y;
    iterations++;
  }
  return iterations;
}

#define SIZE 4000
void main()
{
  int *matrix[SIZE];
  for ( int i=0; i<SIZE; i++ )   /* Line 24 */
  {
    matrix[i] = (int*)malloc( SIZE*sizeof(int) );
  }

  #pragma omp parallel for schedule( dynamic )
  for ( int x=0; x<SIZE; x++ )   /* Line 30 */
   for ( int y=0; y<SIZE; y++ )  /* Line 31 */
   {
     double xv = ( (double)x - (SIZE/2) ) / (SIZE/4);
     double yv = ( (double)y - (SIZE/2) ) / (SIZE/4);
     matrix[x][y] = inSet(xv,yv);
   }

  for ( int x=0; x<SIZE; x++ )   /* Line 38 */
   for ( int y=0; y<SIZE; y++ )  /* Line 39 */
     if ( matrix[x][y] == -7 ) { printf(""); }
}

