#include <pthread.h>
#include <stdlib.h>
#include <stdio.h>

pthread_key_t parameter;

void destructor( void * param )
{
  free( param );
  printf( "Memory freed\n" );
}

void * threadFunc( void * param )
{
  char * mem = malloc( 100 );
  printf( "Mememory allocated\n" );
  pthread_setspecific( parameter, mem );
}

void main()
{
  pthread_t thread;  
  pthread_key_create( &parameter, destructor );
  pthread_create( &thread, 0, threadFunc, 0 );
  pthread_join( thread, 0 );
  pthread_key_delete( parameter );
}
