#include <unistd.h>
#include <stdio.h>
#include <mqueue.h>
#include <string.h>
#include <errno.h>

void main()
{
  int status;
  pid_t f = fork();
  if ( f == 0 )
  { /* Child process */
    mqd_t * queue;
    char message[20];
    queue = mq_open( "/messages", O_WRONLY+O_CREAT, 0777, 0 );
    strncpy( message, "Hello", 6 );
    printf( "Send message %s\n", message );
    mq_send( queue, message, strlen(message)+1, 0 );
    mq_close( queue );
    printf( "Child process completed\n" );
  }
  else
  {
    mqd_t * queue;
    char message[2000];
    queue = mq_open( "/messages", O_RDONLY+O_CREAT, 0777, 0 );
    mq_receive( queue, message, 2000, 0 );
    printf( "Receive message %s\n", message );
    mq_close( queue );
    mq_unlink( "/messages" );
    printf( "Parent process completed\n" );
  }
}
