#include <unistd.h>
#include <stdio.h>

int main()
{
  int status;
  int pipes[2];
  pipe(pipes);
  pid_t f = fork();
  if (f==0)
  { /* Child process */
    close(pipes[0]);
    write(pipes[1],"a",1);
    printf("Child sent 'a'\n");
    close(pipes[1]);
  }
  else
  {
    char buffer[11];
    close(pipes[1]);
    int len=read(pipes[0],buffer,10);
    buffer[len]=0;
    printf("Parent received %s\n",buffer);
    close(pipes[0]);
  }
  return 0;
}
