#include <Windows.h>

int _tmain( int argc, _TCHAR* argv[] )
{
  HANDLE sharedmutex;
  STARTUPINFO startup_info;
  PROCESS_INFORMATION process_info;


  ZeroMemory( &process_info, sizeof(process_info) );
  ZeroMemory( &startup_info, sizeof(startup_info) );
  startup_info.cb = sizeof(startup_info);
   
  sharedmutex=CreateMutex( 0, 0, L"mymutex12234" );
  if ( GetLastError() != ERROR_ALREADY_EXISTS )
  {
    if ( CreateProcess( argv[0], 0, 0, 0, 0, 0, 0, 0,
                        &startup_info, &process_info )==0 ) 
    {
       printf( "ERROR %i\n", GetLastError() );
    }

    WaitForInputIdle( process_info.hProcess, INFINITE );
  }

  WaitForSingleObject( sharedmutex, INFINITE );

  for (int i=0; i<1000; i++) 
  {
    printf( "Process %i Count %i\n", GetCurrentProcessId(), i );
  } 
  ReleaseMutex( sharedmutex );
  CloseHandle( sharedmutex );
  getchar();
  return 0;
}
